import commands, subprocess

#domid = ""
#domcfg = ""
#wl = ""

#class Domain (gdb.Command):
#	"""Set the domain config file"""
#
#	def __init__(self):
#		super (Domain, self).__init__("domain", gdb.COMMAND_FILES)
#
#	def invoke(self, arg, from_tty):
#		global domcfg, wl
#
#		argv = arg.split()
#		if len(argv) == 0:
#			print "Please specify a config file."
#			return
#
#		print "args: " + arg
#		print argv[0]
#		domcfg = argv[0]
#		try:
#			exec(open(domcfg, "rb").read())
#		except IOError:
#			print "Error reading \"" + domcfg + "\""
#			return
#
#		gdb.execute("file " + kernel)
#		wl = str(gdb.lookup_type("long").sizeof * 8)
#		print "Using domain config file \"" + domcfg + "\""

class RunGDBSX (gdb.Command):
	"""Debug with GDBSX"""

	def __init__(self):
		super (RunGDBSX, self).__init__("run", gdb.COMMAND_RUNNING)

	def invoke(self, arg, from_tty):
		argv = arg.split()
		if len(argv) == 0:
			print "Please specify the domain config file."
			return

		domcfg = argv[0]
		try:
			exec(open(domcfg, "rb").read())
		except IOError:
			print "Error reading \"" + domcfg + "\""
			return

		gdb.execute("file " + kernel)
		wl = str(gdb.lookup_type("long").sizeof * 8)
		print "Using domain config file \"" + domcfg + "\""

		r = commands.getstatusoutput("sudo xm create -p " + domcfg + " | awk 'match($0,/[0-9]+/){print substr($0,RSTART,RLENGTH)}'")
		if r[0] != 0:
			print "Error"
			return
		domid = r[1]
		r = subprocess.call("sudo sh -c \"gdbsx -a " + domid + " " + wl + " 9999 >/dev/null 2>&1 &\"", shell=True)
		if r != 0:
			print "Error"
			return
		print "Domain ID: " + domid
		gdb.execute("target remote localhost:9999")
		self.dont_repeat()

Domain()
RunGDBSX()
