#ifndef __EVENTS_H__
#define __EVENTS_H__

#include <stdint.h>
#include <xen/event_channel.h>
#include "traps.h"

typedef void (*evtchn_handler_t)(evtchn_port_t port, regs_t *regs, void *data);

void event_init();
void force_evtchn_callback(void);
void mask_evtchn(uint32_t port);
void unmask_evtchn(uint32_t port);
evtchn_port_t bind_virq(uint32_t virq);
evtchn_port_t bind_evtchn(evtchn_port_t port, evtchn_handler_t handler, void *data);
void unbind_evtchn(evtchn_port_t port);

#endif
