/* 
 ****************************************************************************
 * (C) 2005 - Grzegorz Milos - Intel Reseach Cambridge
 ****************************************************************************
 *
 *        File: traps.h
 *      Author: Grzegorz Milos (gm281@cam.ac.uk)
 *              
 *        Date: Jun 2005
 * 
 * Environment: Xen Minimal OS
 * Description: Deals with traps
 *
 ****************************************************************************
 */

#ifndef _TRAPS_H_
#define _TRAPS_H_

#include "types.h"

void trap_init();

#define TRAP_PF_PROT   0x1
#define TRAP_PF_WRITE  0x2
#define TRAP_PF_USER   0x4

#endif /* _TRAPS_H_ */
